function createXMLHttpRequest() {
  if (window.XMLHttpRequest) {
    return new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    try {
      return new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      return new ActiveXObject("Microsoft.XMLHTTP");
    }
  }
  return null;
}

var jump = "sc000000.xml";
var jump1 = "";
var jump2 = "";
var jump3 = "";

var id_character = "character";
var id_background = "background";
var id_message = "message";
var id_selection1 = "selection1";
var id_selection2 = "selection2";
var id_selection3 = "selection3";
var id_window = "window";
var id_screen = "screen";
var id_offscreen = "offscreen";
var nextScene = 0;

function getContents(xmlhttp, currentScene) {
  var scene = new Object();
  var sceneElement = xmlhttp.responseXML.documentElement.getElementsByTagName("scene")[currentScene];

  // Background
  if (sceneElement.getElementsByTagName("background").length != 0) {
    scene.loc_background = sceneElement.getElementsByTagName("background")[0].childNodes[0].nodeValue;
  } else {
    scene.loc_background = null;
  }
  
  // Character
  if (sceneElement.getElementsByTagName("character").length != 0) {
    scene.loc_character = sceneElement.getElementsByTagName("character")[0].childNodes[0].nodeValue;
  } else {
    scene.loc_character = null;
  }
  
  // Message
  if (sceneElement.getElementsByTagName("message").length != 0) {
    scene.message = sceneElement.getElementsByTagName("message")[0].childNodes[0].nodeValue;
  } else {
    scene.message = null;
  }

  // Window
  if (sceneElement.getElementsByTagName("window").length != 0) {
    document.getElementById(id_window).style.visibility = sceneElement.getElementsByTagName("window")[0].childNodes[0].nodeValue;
  }

  // Branch
  if (sceneElement.getElementsByTagName("branch").length != 0) {
    var conditions = sceneElement.getElementsByTagName("branch")[0].getElementsByTagName("condition");
    document.getElementById(id_screen).style.visibility = "hidden";
    document.getElementById(id_offscreen).style.visibility = "visible";
    
    scene.message = conditions[0].childNodes[0].nodeValue;
    jump1 = conditions[0].getAttribute("jump");
    document.getElementById(id_selection1).style.visibility = "visible";
    scene.selection = 1;
    if (conditions.length >= 2) {
      scene.message = scene.message + "<br>\n" + conditions[1].childNodes[0].nodeValue;
      jump2 = conditions[1].getAttribute("jump");
      document.getElementById(id_selection2).style.visibility = "visible";
      scene.selection = 2;
    }
    if (conditions.length >= 3) {
      scene.message = scene.message + "<br>\n" + conditions[2].childNodes[0].nodeValue;
      jump3 = conditions[2].getAttribute("jump");
      document.getElementById(id_selection3).style.visibility = "visible";
      scene.selection = 3;
    }
    
  } else {
    scene.selection = 0;
  }

  // Jump
  if (sceneElement.getElementsByTagName("jump").length != 0) {
    scene.jump = sceneElement.getElementsByTagName("jump")[0].childNodes[0].nodeValue;
  } else {
    scene.jump = null;
  }

  return scene;
}

function next(value) {
  if (value != null) {
    switch (value) { 
      case 1:
        jump = jump1;
        break;
      case 2:
        jump = jump2;
        break;
      case 3:
        jump = jump3;
        break;
    }
    document.getElementById(id_selection1).style.visibility = "hidden";
    document.getElementById(id_selection2).style.visibility = "hidden";
    document.getElementById(id_selection3).style.visibility = "hidden";
    document.getElementById(id_offscreen).style.visibility = "hidden";
    document.getElementById(id_screen).style.visibility = "visible";
    nextScene = 0;
  }

  var xmlhttp = createXMLHttpRequest();
  xmlhttp.open("GET", jump);
  xmlhttp.onreadystatechange = function() {
    if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200)) {
      // var scene = xmlhttp.responseXML.documentElement.getElementsByTagName("scene")[nextScene];
      var scene = getContents(xmlhttp, nextScene);

      // Beckground
      if (scene.loc_background != null) {
        document.getElementById(id_background).src = scene.loc_background;
      }

      // Character
      if (scene.loc_character != null) {
        // var imageUrl = scene.getElementsByTagName("character")[0].childNodes[0].nodeValue;
        if (scene.loc_character.indexOf("none") == 0) {
          document.getElementById(id_character).src = 'none.png';
          document.getElementById(id_character).style.visibility = "hidden";
        } else {
          document.getElementById(id_character).src = scene.loc_character;
          document.getElementById(id_character).style.visibility = "visible";
        }
      }

      // Text
      if (scene.message != null) {
        document.getElementById(id_message).innerHTML = scene.message;
      }

      // Jump
      if (scene.jump != null) {
        jump = scene.jump;
        nextScene = 0;
      } else {
        nextScene++;
      }

      // Go back first scene
      if (nextScene == xmlhttp.responseXML.documentElement.getElementsByTagName("scene").length ) {
        nextScene = 0;
      }
    }
  }
  xmlhttp.send('');
}

function onKeyUp(e) {
  var keyCode = null;
  if (document.all) {
    keyCode = event.keyCode;
  } else {
    keyCode = e.which;
  }

  if (keyCode == 32) {
    next();
    return false;
  }
}
document.onkeyup = onKeyUp;

function opacity1(value) {
  var pvalue = value * 100;
  document.getElementById(id_selection1).style.filter = "alpha(opacity="+ pvalue + ")";
  document.getElementById(id_selection1).style.MozOpacity = value;
  document.getElementById(id_selection1).style.opacity = value;
}

function opacity2(value) {
  var pvalue = value * 100;
  document.getElementById(id_selection2).style.filter = "alpha(opacity="+ pvalue + ")";
  document.getElementById(id_selection2).style.MozOpacity = value;
  document.getElementById(id_selection2).style.opacity = value;
}

function opacity3(value) {
  var pvalue = value * 100;
  document.getElementById(id_selection3).style.filter = "alpha(opacity="+ pvalue + ")";
  document.getElementById(id_selection3).style.MozOpacity = value;
  document.getElementById(id_selection3).style.opacity = value;
}
